from diffusers import DDPMScheduler, UNet2DModel
from PIL import Image
import torch
import numpy as np

torch.manual_seed(1)

scheduler = DDPMScheduler.from_pretrained("google/ddpm-cat-256")
model = UNet2DModel.from_pretrained("google/ddpm-cat-256").to("cuda")
scheduler.set_timesteps(200)

sample_size = model.config.sample_size
noise = torch.randn((1, 3, sample_size, sample_size)).to("cuda")

# print(noise.shape)
# print(torch.mean(noise))

input = noise
list_input = []

idx_t = 0
for t in scheduler.timesteps:
    print(idx_t)

    with torch.no_grad():
        noisy_residual = model(input, t).sample
        prev_noisy_sample = scheduler.step(noisy_residual, t, input).prev_sample
		
        input = prev_noisy_sample

        # save image
        image = (input / 2 + 0.5).clamp(0, 1)
        image = image.cpu().permute(0, 2, 3, 1).numpy()[0]
        image = Image.fromarray((image * 255).round().astype("uint8"))
        image.save('noise_{}.png'.format(idx_t))


        idx_t += 1


